<?php
/*
Plugin Name: PageRank Widget
Plugin URI: http://geeklad.com/wordpress-pagerank-widget-plugin
Description: Display your PageRank on your WordPress website.  Forget about other complicated PageRank plugins that require the modification of templates with additional PHP code. This plugin simplifies the display of your PageRank by simply displaying it as a widget.  Display your PageRank at a top-domain level or an individual page level.
Author: GeekLad
Version: 0.5
Author URI: http://geeklad.com/
*/

function control_pageRankWidget() {
	$options = $newoptions = get_option('widget_pageRankWidget');
	if ( $_POST["pagerank-widget-submit"] ) {
		$newoptions['level'] = $_POST["pagerank-widget-level"];
	}
	if ( $options != $newoptions ) {
		$options = $newoptions;
		update_option('widget_pageRankWidget', $options);
	}
	if ( empty($options['level']) )
		$level = "pages";
	else
		$level = $options['level'];
?>
			<p><label for="pagerank-widget-title"><?php _e('Display top-level PageRank, or individual pages?<br>'); ?><select id="pagerank-widget-level" name="pagerank-widget-level"><option value="pages"<?php if($level == "pages") echo ' selected="selected"'; ?>>Individual Pages</option><option value="top"<?php if($level == "top") echo ' selected="selected"'; ?>>Top-Level</option></select>
				<br />
			</p>
			<input type="hidden" id="pagerank-widget-submit" name="pagerank-widget-submit" value="1" />
<?php
}

function widget_pageRankWidget() {
//	extract($args);
	$options = get_option('widget_pageRankWidget');
	if ( empty($options['level']) )
		$level = "pages";
	else
		$level = $options['level'];
	
	if ($level == "pages")
		echo display_pageRankWidget($_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"]);
	else
		echo display_pageRankWidget($_SERVER["HTTP_HOST"]);
}

function display_pageRankWidget($url) {
	$pagerank = getpr($url);
	if ($pagerank == -1)
		$pagerank = "N/A";
		
	$output = '<span id="pagerank-widget" style="font-family: Tahoma,Verdana,Arial; font-size: 12px; line-height=12px;">';
	$output .= '	<p></p>';
	$output .= '	<table cellspacing="0" cellpadding="5" style="border: 1px solid black;">';
	$output .= '		<tr>';
	$output .= '			<td align="center" style="line-height: 7px">PageRank</td>';
	$output .= '			<td style="margin: 5px; padding: 10px; background: #008000; font-size: 20px; color: #FFFFFF; line-height: 7px; font-family: Arial;" rowspan="2">' . $pagerank . '</td>';
	$output .= '		</tr>';
	$output .= '		<tr>';
	$output .= '		<td>';
	$output .= '				<table cellspacing="0" cellpadding="0" width="60px" height="8px" style="border: 1px solid black;">';
	$output .= '					<tr>';
	if ($pagerank == "N/A") {
		$output .= '						<td style="width: 80px; background: #808080;"></td>';
	} else {
		$x = (int) $x;
		for ($x=1; $x<=$pagerank; $x++) {
			$output .= '						<td style="background: #008000; width: 8px"></td>';
		}		
		for ($x=$x; $x<=10; $x++) {
			$output .= '						<td style="background: #FFFFFF; width: 8px"></td>';
		}
	}
	$output .= '					</tr>';
	$output .= '				</table>';
	$output .= '			</td>';
	$output .= '		</tr>';
	$output .= '	</table>';
	$output .= '	<span style="font-size: 9px; line-height:9px;">Powered by <a href="http://geeklad.com/wordpress-pagerank-widget-plugin">PageRank Widget</a></span>';
	$output .= '</span>';
	return $output;
}

function post_pageRankWidget($content) {
	if( preg_match('/<!--pagerank-->/i', $content)) {
		$splitcontent = preg_split('/<!--pagerank-->/i', $content, 2);
		$content = $splitcontent[0] . display_pageRankWidget($_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"]) . $splitcontent[1];
	}
	return $content;
}

// This is the actual PageRank checking code
  // Source: http://www.pagerankcode.com/download-script.html
  define('GOOGLE_MAGIC', 0xE6359A60);
  function _zeroFill($a, $b){
   	$z = hexdec(80000000);
   	if ($z & $a){
     	$a = ($a>>1);
     	$a &= (~$z);
     	$a |= 0x40000000;
     	$a = ($a>>($b-1));
   	}else
     	$a = ($a>>$b);
   	return $a;
 	}
  function _mix($a,$b,$c){
   	$a -= $b; $a -= $c; $a ^= (_zeroFill($c,13));
   	$b -= $c; $b -= $a; $b ^= ($a<<8);
   	$c -= $a; $c -= $b; $c ^= (_zeroFill($b,13));
   	$a -= $b; $a -= $c; $a ^= (_zeroFill($c,12));
   	$b -= $c; $b -= $a; $b ^= ($a<<16);
   	$c -= $a; $c -= $b; $c ^= (_zeroFill($b,5));
   	$a -= $b; $a -= $c; $a ^= (_zeroFill($c,3));
   	$b -= $c; $b -= $a; $b ^= ($a<<10);
   	$c -= $a; $c -= $b; $c ^= (_zeroFill($b,15));
   	return array($a,$b,$c);
  }
  function _GoogleCH($url, $length=null, $init=GOOGLE_MAGIC){
   	if(is_null($length))
     	$length = sizeof($url); 
   	$a = $b = 0x9E3779B9;
   	$c = $init;
   	$k = 0;
   	$len = $length;
   	while($len >= 12){
     	$a += ($url[$k + 0] + ($url[$k + 1] << 8) + ($url[$k + 2] << 16) + ($url[$k + 3] << 24));
     	$b += ($url[$k + 4] + ($url[$k + 5] << 8) + ($url[$k + 6] << 16) + ($url[$k + 7] << 24));
     	$c += ($url[$k + 8] + ($url[$k + 9] << 8) + ($url[$k + 10] << 16) + ($url[$k + 11] << 24));
     	$_mix = _mix($a,$b,$c);
     	$a = $_mix[0]; $b = $_mix[1]; $c = $_mix[2];
     	$k += 12;
     	$len -= 12;
   	}
   	$c += $length;
   	switch($len){
     	case 11: $c += ($url[$k + 10] << 24);
     	case 10: $c += ($url[$k + 9] << 16);
     	case 9 : $c += ($url[$k + 8] << 8);
     	case 8 : $b += ($url[$k + 7] << 24);
     	case 7 : $b += ($url[$k + 6] << 16);
     	case 6 : $b += ($url[$k + 5] << 8);
     	case 5 : $b += ($url[$k + 4]);
     	case 4 : $a += ($url[$k + 3] << 24);
     	case 3 : $a += ($url[$k + 2] << 16);
     	case 2 : $a += ($url[$k + 1] << 8);
     	case 1 : $a += ($url[$k + 0]);
   	}
   	$_mix = _mix($a,$b,$c);
   	return $_mix[2];
  }
  function _strord($string){
   	for($i = 0;$i < strlen($string);$i++)
     	$result[$i] = ord($string{$i});
   	return $result;
}
  function getpr($url){
   	$pagerank = -1;
   	$ch = "6"._GoogleCH(_strord("info:" . $url));
   	$fp = fsockopen("www.google.com", 80, $errno, $errstr, 30);
   	if($fp){
     	$out = "GET /search?client=navclient-auto&ch=" . $ch . "&features=Rank&q=info:" . $url . " HTTP/1.1\r\n";
     	$out .= "Host: www.google.com\r\n";
     	$out .= "Connection: Close\r\n\r\n";
     	fwrite($fp, $out);
     	while (!feof($fp)){
       	$data = fgets($fp, 128);
       	$pos = strpos($data, "Rank_");
       	if($pos === false){
       	}else
         	$pagerank = substr($data, $pos + 9);
     	}
     	fclose($fp);
   	}
   	return $pagerank;
}
?>